include kernel32.inc
includelib kernel32.lib
.code
; 

; LoadFile loads a disk file into a memory buffer of the same length,
; lpName is the disk file to open
; hMem$ is the memory block that the file was copied to
; Return values: eax is pointer to memory
;				 ecx file size in bytes
; 

LoadFile proc lpName:DWORD

    LOCAL hFile     :DWORD
    LOCAL fl        :DWORD
    LOCAL bRead     :DWORD
    LOCAL hMem$     :DWORD      ; source memory handle
    
    invoke CreateFile,lpName,GENERIC_READ,0,NULL,OPEN_EXISTING,NULL,NULL
    mov hFile, eax

    invoke GetFileSize,hFile,NULL
    mov fl, eax

    stralloc fl
    mov hMem$, eax      ; source file memory

    invoke ReadFile,hFile,hMem$,fl,ADDR bRead,NULL
    invoke CloseHandle,hFile
	mov eax,hMem$
	mov ecx,fl
    ;strfree hMem$			the calling proc has to free allocated memory when done

    ret

LoadFile endp
; 

; 

; ReadLine proc reads a line from a file into a buffer
; Contentw of the buffer are placed into Control
; Also check Masm macro help file for discription of the macro readline
; 
ReadLine Proc hWin:HWND,FileName:dword,Control:dword
LOCAL buffer1 [128]:byte
LOCAL sPos:dword
	mov sPos,0
	xor ecx,ecx
	l1:
	invoke readline,FileName,addr buffer1,sPos
	cmp eax,0
	je getout
	mov sPos,eax
	cmp ecx,0
	je emptyline
	fn SendDlgItemMessage,hWin,Control,LB_ADDSTRING,0,addr buffer1
	emptyline:
	mov buffer1,0
	jmp l1
	getout:

	
	ret

ReadLine endp